Drupal.behaviors.simpleDateRepeatUi = function() {
  Drupal.simpleDateRepeatUi();
}

Drupal.simpleDateRepeatUi = function() {
  var chb = $('.simple-repeat-check');
  var rruleDesc = $('.rrule-desc');
  var form = '#node-form';
  var $date = '';
  var date_val = '';
  var $fieldname = '';
  
  $dialog = function(args) {
  	$('.repeat-popup').dialog(args);
  }
  init = function() {
  	$dialog({
  	  autoOpen: false,
  	  draggable: false,
  	  modal: true,
  	  resizable: false,
  	  title: Drupal.t('Repeats'),
  	  closeText: '',
  	  buttons: {
  	    'Done': function() {$dialog('close'); saveRepeat();},
  	    'Cancel': function() {$dialog('close'); uncheck();},
  	  },
  	  
    });
    var link = $('<a></a>');
    link.attr('href', '#');
    link.addClass('rrule-edit');
    link.text(Drupal.t('Edit'));
    link.appendTo(chb.parent().parent());
    if(!chb.is(':checked')) {
    	$('.rrule-edit').hide();
    }
    attachEvents();
    $('#repeat-byday, #repeat-bymonth, .repeat-clone').hide();
    $('.rrule-sum').css('display', 'block');
  }
  
  uncheck = function() {
  	chb.attr('checked', false);
  	clearRepeat();
  }
  
  attachEvents = function() {
  	chb.bind('change', function () {
  	  if($(this).is(':checked')) {
  	  	open();
  	  }
  	  else {
  	  	clearRepeat()
  	  }
  	});
  	$('.rrule-edit').live('click', function() {
  	  open();
  	  return false;
  	});
  	$(form).bind('submit', function() { saveRepeat(true); });
  	$('#repeat-freq select').live('change', function() { showExtra($(this)); }).trigger('change');
  	$('.repeat-popup :input').live('change', function() { updateDesc(true); });
  }
  
  open = function() {
    $fieldname = $('#repeat-byday').attr('rel');
    inputname = 'input[name="' + $fieldname +  '[value][date]"]';
    date_val = $(inputname).val();
    if(date_val != '') {
      $date = new Date(date_val);
    }
    $('.repeat-clone').empty().remove();
  	$dialog('open');
  	$('#repeat-freq select').trigger('change');
  }
  
  clearRepeat = function() {
    hideExtra();
  	rruleDesc.hide();
  	$('.rrule-edit').hide();
  }
  
  saveRepeat = function(noAjax) {
  	$clone = $('.repeat-popup').clone();
  	$('.repeat-clone').empty().remove();
  	$clone.addClass('repeat-clone').removeClass('repeat-poup').appendTo(form);
  	if (!noAjax){
  	  updateDesc();
  	  rruleDesc.show();
  	}
  	$('.rrule-edit').show();
  }
  
  updateDesc = function(only) {
    if (!only) {
      txt = $('.repeat-popup .rrule-desc').text();
      rrule.text(txt);
      return;
    }
  	$url = Drupal.settings.basePath + 'date_repeat_rrule_desc';
  	$data = $('.repeat-popup :input').serialize();
  	$data = $data + '&' + $fieldname + '[value][date]=' + date_val;
  	$.ajax({
      url: $url,
      data: $data,
      dataType: 'json',
      type: 'POST',
      success: function(data) {
        if (only === true) {
         $('.repeat-popup .rrule-desc').text(data.rrule);
         return;
        }
      },
  	});
  }
  
  showExtra = function(input) {
    hideExtra();
    if (input.val() == 'WEEKLY'){
      showByDay();
    }
    if (input.val() == 'MONTHLY'){
      showByMonthDay();
    }
    
  }
  
  hideExtra = function() {
    hideByDay();
    hideByMonthDay();
  }
  
  showByDay = function() {
    if ($date) {
      day = $date.getDay();
      $('#repeat-byday input[type="checkbox"]').eq(day).attr('checked', true);
    }
    $('#repeat-byday').show();
  }
  hideByDay = function() {
    $('#repeat-byday input[type="checkbox"]').attr('checked', false);
    $('#repeat-byday').hide();
  }
  
  showByMonthDay = function() {
    $('#repeat-bymonth').show();
  }
  hideByMonthDay = function() {
    $('#repeat-bymonth').hide();
  }
  
  init();
}
